#include	<mystd.h>

BYTE	ring[0x1000];
WORD	*dt0,*dt1,*dt4;
BYTE	*dt3;
BYTE huge *dt2;
BYTE	*virt;
BYTE	palette[0x300];

void	ViewMap(void);
void	LoadFile(BYTE huge *dest,int idm,int ids,long size);
void	DecodeMem(BYTE huge *ibufor,BYTE huge *obufor,long len,long olen);
BYTE huge	*ReadBufor(long *len,int id,int sub);
void	ReadPal(char *fname);
void	Convert(void);

main(){
	int	ReadFlag,ExitFlag=FALSE;
	char	MapSelect;

	printf("WMLMM (tm)   \"LORD OF THE RINGS vol.I\" Map Manager   Version 2.0   5-Sep-99\n");
	printf("Copyright (c) 1996,1999 by Wojciech Migda, All Rights Reserved ?\n");
	dt0=MyCalloc(0x6000,1);
	dt1=MyCalloc(0xa000,1);
	dt2=MyCalloc(0x14000,1);
	dt3=MyCalloc(0x500,1);
	dt4=MyCalloc(0x2000,1);
	virt=MK_FP(0xa000,0x0000);
	do{
		ReadFlag=FALSE;
		printf("\nSelect desired map set :\n");
		printf("  0. EXIT,\n");
		printf("  1. Shire,\n  2. Shire underground,\n  3. Barrow Downs,\n  4. Barrow Downs underground,\n");
		printf("  5. Bree,\n  6. Bree underground,\n  7. Rivendell,\n  8. Rivendell underground,\n");
		printf("  9. Moria I,\n  A. Moria II,\n  B. Lorien,\n  C. Mordor,\n  D. Mordor underground,\n\n>");
		do{
			MapSelect=getch();
			if(MapSelect==0x00) getch();
			MapSelect=toupper(MapSelect);
		}while(memchr("0123456789ABCD",MapSelect,14)==NULL);
		printf("%c\n",MapSelect);
		switch(MapSelect){
			case '0' :	ExitFlag=TRUE;
					break;
			case '1' :	LoadFile((BYTE *)dt0,0,4,0x6000);
					LoadFile((BYTE *)dt1,0,3,0xa000);
					LoadFile(dt2,0,2,0x14000);
					LoadFile((BYTE *)dt4,0,7,0x2000);
					ReadPal("SHIRE1.PAL");
					Convert();
					break;
			case '2' :	LoadFile((BYTE *)dt0,0,12,0x6000);
					LoadFile((BYTE *)dt1,0,11,0xa000);
					LoadFile(dt2,0,10,0x14000);
					LoadFile((BYTE *)dt4,0,15,0x2000);
					ReadPal("SHIRE2.PAL");
					Convert();
					break;
			case '3' :	LoadFile((BYTE *)dt0,0,4,0x6000);
					LoadFile((BYTE *)dt1,0,3,0xa000);
					LoadFile(dt2,0,2,0x14000);
					LoadFile((BYTE *)dt4,1,7,0x2000);
					ReadPal("BARROW1.PAL");
					Convert();
					break;
			case '4' :	LoadFile((BYTE *)dt0,0,12,0x6000);
					LoadFile((BYTE *)dt1,0,11,0xa000);
					LoadFile(dt2,0,10,0x14000);
					LoadFile((BYTE *)dt4,1,15,0x2000);
					ReadPal("BARROW2.PAL");
					Convert();
					break;
			case '5' :	LoadFile((BYTE *)dt0,0,4,0x6000);
					LoadFile((BYTE *)dt1,0,3,0xa000);
					LoadFile(dt2,0,2,0x14000);
					LoadFile((BYTE *)dt4,1,23,0x2000);
					ReadPal("BREE1.PAL");
					Convert();
					break;
			case '6' :	LoadFile((BYTE *)dt0,0,12,0x6000);
					LoadFile((BYTE *)dt1,0,11,0xa000);
					LoadFile(dt2,0,10,0x14000);
					LoadFile((BYTE *)dt4,1,31,0x2000);
					ReadPal("BREE2.PAL");
					Convert();
					break;
			case '7' :	LoadFile((BYTE *)dt0,1,36,0x6000);
					LoadFile((BYTE *)dt1,1,35,0xa000);
					LoadFile(dt2,1,34,0x14000);
					LoadFile((BYTE *)dt4,1,39,0x2000);
					ReadPal("RIVEN1.PAL");
					Convert();
					break;
			case '8' :	LoadFile((BYTE *)dt0,0,12,0x6000);
					LoadFile((BYTE *)dt1,0,11,0xa000);
					LoadFile(dt2,0,10,0x14000);
					LoadFile((BYTE *)dt4,1,47,0x2000);
					ReadPal("RIVEN2.PAL");
					Convert();
					break;
			case '9' :	LoadFile((BYTE *)dt0,1,60,0x6000);
					LoadFile((BYTE *)dt1,1,59,0xa000);
					LoadFile(dt2,1,58,0x14000);
					LoadFile((BYTE *)dt4,1,63,0x2000);
					ReadPal("MORIA1.PAL");
					Convert();
					break;
			case 'A' :	LoadFile((BYTE *)dt0,0,12,0x6000);
					LoadFile((BYTE *)dt1,0,11,0xa000);
					LoadFile(dt2,0,10,0x14000);
					LoadFile((BYTE *)dt4,1,79,0x2000);
					ReadPal("MORIA2.PAL");
					Convert();
					break;
			case 'B' :	LoadFile((BYTE *)dt0,1,68,0x6000);
					LoadFile((BYTE *)dt1,1,67,0xa000);
					LoadFile(dt2,1,66,0x14000);
					LoadFile((BYTE *)dt4,1,71,0x2000);
					ReadPal("LORIEN1.PAL");
					Convert();
					break;
			case 'C' :	LoadFile((BYTE *)dt0,1,36,0x6000);
					LoadFile((BYTE *)dt1,1,35,0xa000);
					LoadFile(dt2,1,34,0x14000);
					LoadFile((BYTE *)dt4,1,87,0x2000);
					ReadPal("MORDOR1.PAL");
					Convert();
					break;
			case 'D' :	LoadFile((BYTE *)dt0,1,60,0x6000);
					LoadFile((BYTE *)dt1,1,59,0xa000);
					LoadFile(dt2,1,58,0x14000);
					LoadFile((BYTE *)dt4,1,95,0x2000);
					ReadPal("MORDOR2.PAL");
					Convert();
					break;
			default :	ReadFlag=TRUE;
		}
		if((ReadFlag==FALSE)&&(ExitFlag==FALSE)) ViewMap();
	}while(ExitFlag!=TRUE);
	return 0;
}

void	LoadFile(BYTE huge *dest,int idm,int ids,long size){
	long	len;
	BYTE huge	*src;
	src=ReadBufor(&len,idm,ids);
	DecodeMem(src,dest,len,size);
	free(src);
}

void	DecodeMem(BYTE huge *ibufor,BYTE huge *obufor,long len,long olen){
	long	icnt,ocnt=0;
	int	code,lp,rcnt=0xfee;
	BYTE	status;
	int	replen,repoff;

//	FILE	*ofile;

	for(icnt=0;icnt<len;){
		status=ibufor[icnt];
		icnt++;
		for(lp=0;lp<8;lp++){
			code=status&0x01;
			status>>=1;
			switch(code){
				case 0x00 :	repoff=ibufor[icnt];
					icnt++;
					repoff|=(ibufor[icnt]&0xf0)<<4;
					replen=(ibufor[icnt]&0x0f)+3;
					icnt++;
					for(;replen>0;replen--){
						if(ocnt<olen) obufor[ocnt]=ring[rcnt]=ring[repoff];
						ocnt++;
						rcnt++;
						rcnt&=0xfff;
						repoff++;
						repoff&=0xfff;
					}
					break;
				case 0x01 :	if(ocnt<olen) obufor[ocnt]=ring[rcnt]=ibufor[icnt];
					rcnt++;
					rcnt&=0xfff;
					icnt++;
					ocnt++;
					break;
			}
		}
	}
//	printf("%04lX\n",ocnt);
//	ofile=MyOpen("output","wb");
//	LargeWrite(obufor,ocnt,ofile,"output");
//	fclose(ofile);
}

BYTE huge	*ReadBufor(long *len,int id,int sub){
	FILE	*ifile,*indfile;
	BYTE	*bufor;
	long	start,end;
	if(id==0){
		ifile=MyOpen("map0.dat","rb");
		indfile=MyOpen("map0.ndx","rb");
		if((sub<=0)||(sub>16)) sub=0;
		if(FileSize(ifile)!=146217L){
			printf("Fatal Error. Unknown version of LotR.\n");
			exit(1);
		}
	}
	else{
		ifile=MyOpen("map1.dat","rb");
		indfile=MyOpen("map1.ndx","rb");
		if((sub<=0)||(sub>96)) sub=0;
		if(FileSize(ifile)!=323435L){
			printf("Fatal Error. Unknown version of LotR.\n");
			exit(1);
		}
	}
	fseek(indfile,sub*4,SEEK_SET);
	MyRead(&start,4,1,indfile,"map.ndx");
	if(ftell(indfile)==FileSize(indfile)) end=FileSize(ifile);
	else MyRead(&end,4,1,indfile,"map.ndx");
	if(end==start){
		printf("Null block length.\n");
		exit(0);
	}
	*len=end-start;
	bufor=MyCalloc(*len,1);
	fseek(ifile,start,SEEK_SET);
        LargeRead(bufor,*len,ifile,"map.dat");
	fclose(ifile);
	fclose(indfile);
	return bufor;
}

void	ViewMap(void){
	auto int	lp,ExitFlag=FALSE;
	auto char	ch;
	auto int	lpx,lpy,x=0,y=0;
	auto int	n16,n4,n;
	asm{
		mov	ax,0x0013
		int	0x10
	}
/*	for(lp=0;lp<768;lp++){
		asm{
			lea	bx,palette
			add	bx,lp
			sar	byte ptr [bx],2
			adc	byte ptr [bx],0
		}
	}*/
	asm{
		mov	ax,0x1012
		xor	bx,bx
		mov	cx,0x100
		lea	dx,palette
		push	ds
		pop	es
		int	0x10
	}
	do{
		for(lpy=y;lpy<(y+192);lpy++){
			for(lpx=x;lpx<(x+256);lpx++){
				n16=dt4[(lpx>>4)+((lpy&0xfff0)<<2)];
				n4=dt0[(n16<<4)+((lpx&0x0f)>>2)+(lpy&0x0c)];
				n=dt1[(n4<<4)+(lpx&3)+((lpy&3)<<2)];
				asm{
					mov	ax,lpy
					sub	ax,y
					mov	bl,0xc0
					div	bl
					mov	al,00
					mov	bx,ax
					shr	ax,2
					add	bx,ax
					mov	ax,lpx
					sub	ax,x
					add	bl,al
					adc	bh,0
					les	si,dt3
					add	si,n
					mov	al,es:[si]
					les	di,virt
					add	di,bx
					stosb
				}
			}
		}
		ch=getch();
		if(ch==0x00) ch=getch();
		switch(ch){
			case 0x1b :	ExitFlag=TRUE;
					break;
			case 0x47 :	x=0;y=0;		//HOME
					break;
			case 0x48 :	if(y>=16) y-=16;	//UP
					break;
			case 0x49 :	if(y>=128) y-=128;	//PGUP
					break;
			case 0x4b :	if(x>=16) x-=16;	//LEFT
					break;
			case 0x4d :	if(x<=752) x+=16;	//RIGHT
					break;
			case 0x4f :	x=768;y=832;		//END
					break;
			case 0x50 :	if(y<=816) y+=16;	//DOWN
					break;
			case 0x51 :	if(y<=704) y+=128;	//PGDN
					break;
			case 0x74 :	if(x<=640) x+=128;	//CT-RIGHT
					break;
			case 0x73 :	if(x>=128) x-=128;	//CT_LEFT
					break;
		}
	}while(ExitFlag==FALSE);
	asm{
		mov	ax,0x0003
		int	0x10
	}
}

void	Convert(void){
	int	lp1,lp2;
	WORD	red,green,blue;
	char	color;
	long	best,cur;
	for(lp1=0;lp1<1280;lp1++){
		red=green=blue=0;
		for(lp2=0;lp2<64;lp2++){
			red+=palette[0+dt2[lp1*64+lp2]*3];
			green+=palette[1+dt2[lp1*64+lp2]*3];
			blue+=palette[2+dt2[lp1*64+lp2]*3];
		}
		best=0x7fffffffL;
		for(lp2=0;lp2<256;lp2++){
			cur=(red-palette[0+lp2*3]*64L)*(red-palette[0+lp2*3]*64L);
			cur+=(green-palette[1+lp2*3]*64L)*(green-palette[1+lp2*3]*64L);
			cur+=(blue-palette[2+lp2*3]*64L)*(blue-palette[2+lp2*3]*64L);
			if(cur<best){
				best=cur;
				color=lp2;
			}
		}
		dt3[lp1]=color;
	}
}

void	ReadPal(char *fname){
	FILE	*ifile;
	ifile=MyOpen(fname,"rb");
	MyRead(palette,768,1,ifile,fname);
	fclose(ifile);
}
